Subject: Re: CCL:Reusing the NAMD code to build C++ simulation program

From: masakatsu-ito(at)aist.go.jp
Date: Sat, 09 Aug 2003 03:58:08 +0900 (JST)

Dear Markus,

Thank you for your quick reply. As you wrote, Mindy,
a sequential version of NAMD, helped me a lot.
It was easy to reuse and modify its code.

Actually we developed a C++ framework to generate variants of 
simulation programs and first examined its extensibility and validity 
by assembling the Mindy code and our code.
The framework provides implementation of a replica-exchange method (which is also
referred as parallel tempering), and one of its flexibility is the
abstract class for a force field. 
Its subclass was derived to delegate the force field calculation to 
Mindy objects and 
to build an executable for replica-exchange method simulation.

Now that we have measured the effectiveness of the simulation method
with a small molecule, I like to challenge more larger molecules such
as a protein-ligand complex. But force-field evaluation in such system
has to be accelerated by an efficient algorithm
like PME which is not implemented by Mindy. 

Thus I rephrase my question. Could somebody give me an explanation
if it is possible to use the NAMD code instead of the Mindy one 
and how to incorporate its Charm++ code into a C++ framework.

I would appreciate any suggestion or hints.

Thanks in advance.

Masakatsu Ito , Ph.D

Grid Technology Research Center
National Institute of Advanced Industrial Science and Technology
Tsukuba Central 2, Tsukuba, Ibaraki 305-8568 Japan
Phone : +81-29-861-5730  Fax : +81-29-861-5301
E-mail masakatsu-ito(at)aist.go.jp
URL http://met.sourceforge.net/

From: Markus Dittrich <markus(at)ks.uiuc.edu>
Subject: Re: CCL:Reusing the NAMD code to build C++ simulation program

> Dear Masakatsu,
> 
> The TCBG group does offer an MD code called
> MINDY which is derived form NAMD source code
> written solely in C++. Maybe this will be of
> help to you.
> 
> http://www.ks.uiuc.edu/Development/MDTools/mindy/
> 
> 
> 
> cheers,
> MARKUS
> 
> On Fri, 8 Aug 2003 masakatsu-ito(at)aist.go.jp wrote:
> 
> > Dear CCL'ers,
> > 
> > I am wondering if it is easy to reuse the NAMD code to build C++
> > simulation program. My question might sound strange because NAMD is so
> > famous for its high extensibility and object-oriented design with
> > C++. But NAMD is actually coded in Charm++, an extended C++ for
> > parallelization, so that the problem is that a programmer has to deal
> > with Charm++ syntax in the NAMD code and its execution model for
> > parallel computation.  So, could somebody give me a brief explanation
> > how the NAMD code can be incorporated into C++ framework, or if it is
> > possible.
> > 
> > I would appreciate any suggestion or references for a simulation
> > program which is built by adding C++ code to the NAMD code.
> > 
> > Thanks a lot in advance.